package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.Polygon;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class PolygonNode extends Renderable {

	private Polygon p;
	private String text;

	public PolygonNode(Polygon p, CheckStatus cs) {
		this.p = p;
		setStatus(cs);
	}

	@Override
	public void refreshTextColor() {
		if (!p.isValidated()) {
			setStatus(CheckStatus.NOT_CHECKED);
		} else if (p.containsAnyError()) {
			setStatus(CheckStatus.ERROR);
		} else {
			setStatus(CheckStatus.OK);
		}
	}

	@Override
	public String getText() {
		if (text == null) {
			text = "Polygon " + p.getGmlId().getGmlString();
		}
		return text;
	}

	@Override
	public void visit(Renderer renderer) {
		renderer.highlight(p);
	}

}
